#
#  Functions to deal with the refinement icon, which is a little bitmap.
#  $Id: ismap_icon.pl,v 1.1.1.1 1997/02/05 23:02:14 fox Exp $
#
#  The function ismap_icon::coords2code takes a pair of coordinates (location
#  of the click inside the refinement icon) and is expected to return a
#  refinement code number from 0 to 4 (0=NW,1=NE,2=SW,3=SE,4=whole image).  If
#  you make a new icon, you must modify the function.  The icon must be an
#  image/gif. 
#

package ismap_icon;
use strict 'vars';

$ismap_icon::IconFile = "4.gif";

#
# Initialization
#
sub init {
    open(F, $ismap_icon::IconFile)
        or die "*** Reading refinement icon in $ismap_icon::IconFile: $!";
    local($/) = undef;
    $ismap_icon::Icon = <F>;
}

sub refine_icon_url { "http://%4%/" }

sub refine_icon { $ismap_icon::Icon }

sub make_refinable {    (shift @_) . ";;"   }
    
sub is_refinement {
    my $url = shift;
    if ($url =~ s!;;\?(\d+),(\d+)/?!!) {
        return ($url, &coords2code($1,$2));
    } else {
        return ($url, undef);
    }
}

sub coords2code {
    my($x,$y) = @_;
    # check for center; otherwise quadrantize
    ($x >= 4 && $x <= 10 && $y >= 4 && $y <= 10)
        ? 4 : (($x > 7) << 1) + ($y > 7);
}

1;
